//fichier Validateur.java
import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import javax.xml.parsers.*;
/**
* Ce programme est inspir de Xerces-J. Il a t modifi
* par Daniel Lemire pour le cours "Gestion de l'information 
* avec XML".
*
* Date de la premire modification: 5 novembre 2004.
*
* Il suffit de compiler le programme avec 
* "javac Validateur.java".
* On peut ensuite valider un document en faisant 
* "java Validateur monfichier.xml".
*
*/
public class Validateur extends DefaultHandler {



    public Validateur() {
    }
  
  
    public void warning(SAXParseException ex) 
    throws SAXException {
        printError("Avertissement", ex);
    }

    public void error(SAXParseException ex) 
    throws SAXException {
        printError("Erreur", ex);
    }

    public void fatalError(SAXParseException ex) 
    throws SAXException {
        printError("Erreur fatale", ex);
    }

    protected void printError(String type, SAXParseException ex) {
        System.err.print("[");
        System.err.print(type);
        System.err.print("] ");
        if (ex== null) {
            System.out.println("!!!");
        }
        String systemId = ex.getSystemId();
        if (systemId != null) {
            int index = systemId.lastIndexOf('/');
            if (index != -1)
                systemId = systemId.substring(index + 1);
            System.err.print(systemId);
        }
        System.err.print(" ligne: ");
        System.err.println(ex.getLineNumber());
        System.err.println(", colonne: ");
        System.err.print(ex.getColumnNumber());
        System.err.print(", description: ");
        System.err.print(ex.getMessage());
        System.err.println();
        System.err.flush();

    }

    public static void main(String argv[]) 
    throws org.xml.sax.SAXException,
    javax.xml.parsers.ParserConfigurationException {
        Validateur counter =  new Validateur();
        PrintWriter out = new PrintWriter(System.out);
        XMLReader parser = null;
        parser = SAXParserFactory.newInstance().newSAXParser().
        getXMLReader();
        parser.setContentHandler(counter);
        parser.setErrorHandler(counter);
        parser.setFeature("http://xml.org/sax/features/validation",
        true);
        parser.setFeature("http://xml.org/sax/features/namespaces",
        true);
        try {
           parser.parse(argv[0]);
        } catch (SAXParseException e) { 
        } catch (Exception e) {
                System.err.println("erreur: Erreur de traitement -"
                +e.getMessage());
        }
    }
}

